#include <os.h>
#include <iostream>
#include <libndls.h>
#include <vector>
#include <algorithm>

#include "screen.h"
#include "gl2d.h"

scr_type_t type;
unsigned int size;
uint8_t *screen;

void scr_init()
{
    type = SCR_320x240_565;
    size = (320*240/2) * 4;
    screen = new uint8_t[size];
    scr_fill(255, 255, 255);
}

void scr_uninit() {
    delete[] screen;
    lcd_init(SCR_TYPE_INVALID);
}

void scr_setPixel(uint16_t c, unsigned int pitch) {
    // On color models, each pixel is represented in 16-bit high color
    // On classic models, each pixel is 4 bits grayscale, 0 is black and 15 is white

	//int a,b;
	//a = (int)x; b = (int)y

    //if (a < 320 && b < 240 ) {
        //unsigned int pos = y * SCREEN_WIDTH + x;
    reinterpret_cast<uint16_t*>(screen)[pitch] = c;
    
}

void scr_setPixel(uint16_t c, unsigned int x, unsigned int y) {
    // On color models, each pixel is represented in 16-bit high color
    // On classic models, each pixel is 4 bits grayscale, 0 is black and 15 is white

	//int a,b;
	//a = (int)x; b = (int)y

    if (x < 320 && y < 240) {
    //if (a < 320 && b < 240 ) {
        unsigned int pos = y * SCREEN_WIDTH + x;
        //unsigned int pos = y * SCREEN_WIDTH + x;
        reinterpret_cast<uint16_t*>(screen)[pos] = c;
    }
}

void scr_setPixel(uint8_t r, uint8_t g, uint8_t b, unsigned int x, unsigned int y) {
    // On color models, each pixel is represented in 16-bit high color
    // On classic models, each pixel is 4 bits grayscale, 0 is black and 15 is white

	//int a,b;
	//a = (int)x; b = (int)y

    if (x < 320 && y < 240) {
    //if (a < 320 && b < 240 ) {
        unsigned int pos = y * SCREEN_WIDTH + x;
        //unsigned int pos = y * SCREEN_WIDTH + x;
        reinterpret_cast<uint16_t*>(screen)[pos] = ((r >> 3) << 11) | ((g >> 2) << 5) | (b >> 3);
    }
}

void scr_flip()
{
    lcd_blit(screen, type);
}

void scr_drawHorzLine(uint8_t r, uint8_t g, uint8_t b, int x1, int y1, int x2)
{
    for (int x=x1;x<x2;x++) scr_setPixel(r, g, b, x, y1);
}

void scr_fill(uint8_t r, uint8_t g, uint8_t b) 
{
    uint16_t color;
    color = ((r >> 3) << 11) | ((g >> 2) << 5) | (b >> 3);

    std::fill(reinterpret_cast<volatile uint16_t*>(screen), reinterpret_cast<volatile uint16_t*>(screen + size), color);
}

void scr_fillRect(uint8_t r, uint8_t g, uint8_t b, unsigned int x, unsigned int y, unsigned int w, unsigned int h) {
    for (unsigned int i = x; i < x + w; i++) {
        for (unsigned int j = y; j < y + h; j++) {
            scr_setPixel(r, g, b, i, j);
        }
    }
}

void scr_drawTexture(TEXTURE *tex, int x, int y) {
    const unsigned int numPixels = tex->width * tex->height;



    for (unsigned int i = 0; i < numPixels; ++i) {
        scr_setPixel(tex->bitmap[i], i);
    }

}
