#ifndef SCREEN_H
#define SCREEN_H

#include <os.h>
#include <iostream>
#include <libndls.h>
#include <vector>

#include "gl2d.h"

// extern because will be defined externally
extern scr_type_t type;
extern unsigned int size;
extern uint8_t *screen;



void scr_init();

void scr_uninit();

void scr_setPixel(uint16_t color, unsigned int pitch);

void scr_setPixel(uint16_t color, unsigned int x, unsigned int y);

void scr_setPixel(uint8_t r, uint8_t g, uint8_t b, 
    unsigned int x, unsigned int y);

void scr_flip();
//uint32_t
void scr_drawHorzLine(uint8_t r, uint8_t g, uint8_t b, 
					  int x1, int y1, int x2);

//int compareInt(const void *a, const void *b);

// scr_drawFillPoly(uint8_t r, uint8_t g, uint8_t b, 
//					  std::vector<Vector2> points);

void scr_fill(uint8_t r, uint8_t g, uint8_t b);

void scr_fillRect(uint8_t r, uint8_t g, uint8_t b, 
    unsigned int x, unsigned int y, unsigned int w, unsigned int h);

void scr_drawTexture(TEXTURE *tex, int x, int y);

#endif