#include <stdint.h>
#include <iterator>

#include "texturetools.h"
#include "gl2d.h"

TEXTURE *newTexture(const uint16_t w, const uint16_t h) {
    // TODO: Don't leak on exception
    TEXTURE* tex = new TEXTURE;

    tex->width = w;
    tex->height = h;

    tex->bitmap = new COLOR[w * h]{0};

    return tex;
}

//void deleteTexture(TEXTURE *tex) {
//    delete[] tex->bitmap;
//    delete tex;
//}

TEXTURE *copyTexture(const TEXTURE *tex) {//, TEXTURE &dest)

    TEXTURE *copy = newTexture(tex->width, tex->height);

    std::copy(tex->bitmap, tex->bitmap + tex->width*tex->height, copy->bitmap);

    return copy;
}

/*
void drawTexture(const TEXTURE &tex,
				 uint16_t x, uint16_t y) {
}
*/


/*

    "Photoshopping"

*/

// uint16_t
COLOR get_1d(TEXTURE *tex, int x, int y) { 
    return tex->bitmap[y + y*x]; 
}



//Returns negated texture
//TEXTURE* negatedTexture(const TEXTURE &tex) {
//
//
//}

TEXTURE *greyscaledTexture(const TEXTURE *tex) {
    const unsigned int numPixels = tex->width * tex->height;

    TEXTURE *copy = newTexture(tex->width, tex->height);

    for (unsigned int i = 0; i < numPixels; ++i) {
        const uint16_t rgb16 = tex->bitmap[i];

        const uint8_t red8      = ((rgb16 >> 11)    << 3) & 0x011111;
        const uint8_t green8    = ((rgb16 >> 5)     << 2) & 0x111111;
        const uint8_t blue8     = ((rgb16)          << 3) & 0x011111;

        const uint8_t greyChannel     = ((red8+green8+blue8)/3);

        //const uint16_t greyChannel = (((rgb16 >> 11) + ((rgb16 >> 5) & 0b111111) + (rgb16 & 0b11111)) / 3);

        const uint16_t greyColor = (greyChannel << 8) | (greyChannel << 3) | (greyChannel);

        //const RGB rgb = rgbColor(tex.bitmap[i]);
        //copy.bitmap[i] = (rgb.r.value + rgb.g.value + rgb.g.value + rgb.b.value) >> 5;
        copy->bitmap[i] = greyColor;
    }
    
    return copy;
}